import { Proof, ProofType, Valid, OptionalProp as Optional } from './types';
/**
 * Where the magic happens
 */
declare const prove: {
    <T extends string | number | boolean | symbol | import("./types").Function<[T], Valid> | Record<any, any> | any[] | null | undefined>(valueOrCheck: T | import("./types").Function<[T], Valid>, trs?: import("./types").Function<[T], Valid>[]): Proof<T>;
    /**
     * Proof for javasript primitives
     */
    string: Proof<string>;
    number: Proof<number>;
    boolean: Proof<boolean>;
    symbol: Proof<symbol>;
    null: Proof<null>;
    undefined: Proof<undefined>;
    /**
     * Structured key value Proof
     */
    shape<T_1 extends Record<any, Proof<any>>>(shp: T_1): Proof<{ [Key_4 in keyof ({ [Key_1 in { [Key in keyof T_1]: ProofType<T_1[Key]> extends Optional<any> ? never : Key; }[keyof T_1]]: ProofType<T_1[Key_1]>; } & { [Key_3 in { [Key_2 in keyof T_1]: ProofType<T_1[Key_2]> extends Optional<any> ? Key_2 : never; }[keyof T_1]]?: (ProofType<T_1[Key_3]> extends Optional<infer D> ? ProofType<D> : never) | undefined; })]: ({ [Key_1 in { [Key in keyof T_1]: ProofType<T_1[Key]> extends Optional<any> ? never : Key; }[keyof T_1]]: ProofType<T_1[Key_1]>; } & { [Key_3 in { [Key_2 in keyof T_1]: ProofType<T_1[Key_2]> extends Optional<any> ? Key_2 : never; }[keyof T_1]]?: (ProofType<T_1[Key_3]> extends Optional<infer D> ? ProofType<D> : never) | undefined; })[Key_4]; }>;
    optional<T_2 extends Proof<any>>(prf: T_2): Proof<Optional<T_2>>;
    /**s
     * Structured array Proof
     */
    array<T_3 extends Proof<any>>(arrayOf: T_3): Proof<ProofType<T_3>[]>;
    /**
     * Logical proof which checks that item is one of some type
     */
    or<T_4 extends Proof<any>[]>(...proofs: T_4): Proof<ProofType<T_4[number]>>;
    /**
     * Strict equals
     */
    equals<T_5 extends any>(value: T_5): Proof<T_5>;
};
export default prove;
