import { Proof, Value, Valid } from './types';
/**
 * Type guard utility with guards set for primitives
 */
export declare const is: {
    <T>(fn: (x: unknown) => boolean): (value: any) => value is T;
    null: (value: any) => value is null;
    array: (value: any) => value is unknown[];
    string: (value: any) => value is string;
    number: (value: any) => value is number;
    symbol: (value: any) => value is symbol;
    boolean: (value: any) => value is boolean;
    function: (value: any) => value is Function;
    undefined: (value: any) => value is undefined;
    shape: (value: any) => value is Record<string, any>;
};
/**
 * Proof utilities
 */
export declare const success: <T extends any>(x: T) => import("./types").Tuple<null, T>;
export declare const failure: (err: string, x: unknown) => import("./types").Tuple<string, unknown>;
export declare const isResolved: <T extends any>(x: import("./types").Tuple<string, unknown> | Proof<T> | import("./types").Tuple<null, T>) => x is import("./types").Tuple<string, unknown> | import("./types").Tuple<null, T>;
export declare const isProved: <T extends any>(x: import("./types").Tuple<string, unknown> | import("./types").Tuple<null, T>) => x is import("./types").Tuple<null, T>;
export declare const check: <T extends Proof<any>>(prf: T) => (y: Value) => string | true;
export declare const result: <T extends any>(value: T, result: Valid) => import("./types").Tuple<string, unknown> | import("./types").Tuple<null, T>;
/**
 * Generate output string for all javascript types
 */
export declare const outputString: (val: any) => string;
